package com.seeyon.apps.ocip.exchange.collaboration.manager;

import com.seeyon.ctp.common.content.affair.AffairData;
import com.seeyon.ctp.common.usermessage.MessageReceiver;
import com.seeyon.ocip.exchange.model.col.Affair;
import com.seeyon.ocip.exchange.model.col.ColOperation;
import com.seeyon.ocip.exchange.model.col.ColSummary;

public interface CollaborationExchangeManager {

    void handCollaborationAffair(AffairData data, ColOperation operation, com.seeyon.apps.collaboration.po.ColSummary colSummary);

    /**
     * 带意见
     *
     * @param data
     * @param operation
     * @param colSummary
     * @param opinionContent
     */
    void handCollaborationAffair(AffairData data, ColOperation operation, com.seeyon.apps.collaboration.po.ColSummary colSummary, String opinionContent);

    /**
     * 推送待办并发送消息
     *
     * @param affair
     * @param colSummary
     * @param receiver
     */
    void sendColAndMeg(Affair affair, ColSummary colSummary, MessageReceiver receiver, String sendName, int opinionType, String opinionContent, String sendSysCode);

    /**
     * 催办
     *
     * @param affair
     * @param colSummary
     * @param msgContent
     */
    void sendHasten(Affair affair, ColSummary colSummary, String msgContent, boolean sendMsg);

    /**
     * 回退
     *
     * @param affair
     * @param colSummary
     * @param sendName
     * @param operation
     * @param opinionContent
     * @param isSelf         发起者是否和当前处理人为同一人
     * @param systemCode
     */
    void sendStepBack(Affair affair, ColSummary colSummary, String sendName, ColOperation operation, String opinionContent, boolean isSelf, String systemCode);

    /**
     * 竞争执行
     *
     * @param affair
     * @param colSummary
     */
    void competitionDone(Affair affair, ColSummary colSummary);

    /**
     * 已办
     *
     * @param affair
     * @param colSummary
     * @param sendSysCode
     */
    void sendDone(Affair affair, ColSummary colSummary, String sendSysCode);

    /**
     * 终止
     *
     * @param affair
     * @param colSummary
     * @param sendSysCode
     * @param sendName
     * @param opinionContent
     * @param isSelf
     */
    void sendStop(Affair affair, ColSummary colSummary, String sendSysCode, String sendName, String opinionContent, boolean isSelf);

    /**
     * 新增附言
     *
     * @param affair
     * @param colSummary
     * @param sendName
     */
    void sendComments(Affair affair, ColSummary colSummary, String sendName);

    /**
     * 超期提醒
     *
     * @param affair
     * @param colSummary
     * @param sendName
     * @param opinionContent 区分超期提醒种类，已经超期还是，将要超期
     */
    void sendOvertime(Affair affair, ColSummary colSummary, String sendName , String opinionContent);

    /**
     * 修改正文提醒
     *
     * @param affair
     * @param colSummary
     * @param sendName
     */
    void sendModifyBody(Affair affair, ColSummary colSummary, String sendName);

    /**
     * 意见回复提醒
     *
     * @param affair
     * @param colSummary
     * @param sendName
     */
    void sendCommentsReply(Affair affair, ColSummary colSummary, String sendName);

    /**
     * 收藏
     *
     * @param affair
     * @param colSummary
     * @param sendName
     */
    void sendFavorite(Affair affair, ColSummary colSummary, String sendName);

    /**
     * 转发
     *
     * @param affair
     * @param colSummary
     * @param sendName
     */
    void forward(Affair affair, ColSummary colSummary, String sendName, String sendSysCode);

    /**
     * 暂存待办
     *
     * @param affair
     * @param colSummary
     */
    void sendZcdb(Affair affair, ColSummary colSummary);

    /**
     * 通知，被删除
     *
     * @param affair
     * @param colSummary
     */
    void fireDelete(Affair affair, ColSummary colSummary,String sendSysCode);
}
