package com.seeyon.v3x.mobile.adapter.demo;

import java.io.*;
import java.net.URLEncoder;
import java.util.*;
import com.seeyon.ctp.common.SystemEnvironment;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.util.json.JSONUtil;
import org.apache.log4j.Logger;

import com.seeyon.v3x.mobile.adapter.AdapterMobileMessageManger;
import com.seeyon.v3x.mobile.message.domain.MobileReciver;
import org.springframework.web.client.RestTemplate;

/**
 * DEMO短信
 */
public class AdaptMobileDEMOImpl implements AdapterMobileMessageManger {
	
	private static final Logger LOGGER = Logger.getLogger(AdaptMobileDEMOImpl.class);
	
	/** 短信插件是否启动 */
	/** 用户账号  */
	private String userName;
	/** 用户密码  */
	private String password;
	/**签名***/
	private String sign ;


	@Override
	public String getName() {
		return "测试";
	}

	@Override
	public boolean isAvailability() {
		String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties";
		InputStream in = null;
		String messageUrl;
		try {
			in = new BufferedInputStream(new FileInputStream(filePath));
			Properties p = new Properties();
			BufferedReader bf = new BufferedReader(new InputStreamReader(in, "utf-8"));
			p.load(bf);
			this.userName = p.getProperty("userName");
			this.password = p.getProperty("password");
			this.sign = p.getProperty("sign");
			LOGGER.info("------"+this.userName+"---"+this.password+"---"+this.sign);
			if (Strings.isNotBlank(this.userName) && Strings.isNotBlank(this.password) && Strings.isNotBlank(this.sign)) {
				LOGGER.info("----------初始化短信插件------------");
				System.out.println("---------------初始化短信插件--------------");
				return true;
			} else {
				LOGGER.info("----------短信系统参数配置不全------------");
				System.out.println("---------------短信系统参数配置不全--------------");
				return false;
			}
		}catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}

	@Override
	public boolean isSupportQueueSend() {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public boolean isSupportRecive() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public List<MobileReciver> recive() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean sendMessage(Long messageId, String srcPhone, String destPhone, String content) {
		LOGGER.info("----------开始发送短信------------");
		String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties";
		InputStream in = null;
		String messageUrl;
		try {
			content = URLEncoder.encode(content,"utf-8");
			LOGGER.info("content=" + content);
			LOGGER.info("destPhone=" + destPhone);
			in = new BufferedInputStream(new FileInputStream(filePath));
			Properties p = new Properties();
			BufferedReader bf = new BufferedReader(new InputStreamReader(in, "utf-8"));
			p.load(bf);
			messageUrl = p.getProperty("messageUrl");
			this.userName = p.getProperty("userName");
			this.password = p.getProperty("password");
			this.sign = p.getProperty("sign");
			LOGGER.info("------"+this.userName+"---"+this.password+"---"+this.sign);
			messageUrl = messageUrl +
					"?userName="+this.userName+"&password="+this.password+"&sign="+this.sign+"&phoneList="+destPhone
					+"&content="+content;
			RestTemplate template = new RestTemplate();
			String response = template.postForObject(messageUrl, null, String.class);
			LOGGER.info("response=" + response);
			Map<String, Object> json = (Map<String, Object>) JSONUtil.parseJSONString(response);
			String code = json.get("code").toString();
			if (!"200".equals(code)) {
				LOGGER.error("msg:"+json.get("msg").toString());
				return false;
			}
			LOGGER.info("----------发送短信结束------------");
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}


		@Override
	public boolean sendMessage(Long messageId, String srcPhone,Collection<String> destPhoneList, String content) {
			String phone = null;
			Iterator var6 = destPhoneList.iterator();
			LOGGER.info("-------------------------------群发短信=");
			while(var6.hasNext()) {
				String str = (String)var6.next();
				if (phone != null) {
					phone = phone + "," + str;
				} else {
					phone = str;
				}
			}

			return this.sendMessage(messageId, srcPhone, phone, content);
	}
}


